/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TDmPerson.TDmPersonPath;
import de.ship.db.tables.TDmRecipient.TDmRecipientPath;
import de.ship.db.tables.records.TDmMaillistRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmMaillist extends TableImpl<TDmMaillistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_maillist</code>
     */
    public static final TDmMaillist T_DM_MAILLIST = new TDmMaillist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmMaillistRecord> getRecordType() {
        return TDmMaillistRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_maillist.lastchange</code>.
     */
    public final TableField<TDmMaillistRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_maillist.pk</code>.
     */
    public final TableField<TDmMaillistRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_maillist.fk_element</code>. MAILLIST:
     * reference to study variable
     */
    public final TableField<TDmMaillistRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "MAILLIST: reference to study variable");

    /**
     * The column <code>common_dd.t_dm_maillist.fk_dm_person</code>. MAILLIST:
     * reference to id of person
     */
    public final TableField<TDmMaillistRecord, Integer> FK_DM_PERSON = createField(DSL.name("fk_dm_person"), SQLDataType.INTEGER.nullable(false), this, "MAILLIST: reference to id of person");

    /**
     * The column <code>common_dd.t_dm_maillist.fk_maillist_recip</code>.
     * MAILLIST: reference to type of recipient
     */
    public final TableField<TDmMaillistRecord, Integer> FK_MAILLIST_RECIP = createField(DSL.name("fk_maillist_recip"), SQLDataType.INTEGER.nullable(false), this, "MAILLIST: reference to type of recipient");

    /**
     * The column <code>common_dd.t_dm_maillist.maillist_type</code>. MAILLIST:
     * recpient type: 1 = to, 2 =cc, 3 = bcc
     */
    public final TableField<TDmMaillistRecord, Integer> MAILLIST_TYPE = createField(DSL.name("maillist_type"), SQLDataType.INTEGER.nullable(false), this, "MAILLIST: recpient type: 1 = to, 2 =cc, 3 = bcc");

    private TDmMaillist(Name alias, Table<TDmMaillistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmMaillist(Name alias, Table<TDmMaillistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_maillist</code> table reference
     */
    public TDmMaillist(String alias) {
        this(DSL.name(alias), T_DM_MAILLIST);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_maillist</code> table reference
     */
    public TDmMaillist(Name alias) {
        this(alias, T_DM_MAILLIST);
    }

    /**
     * Create a <code>common_dd.t_dm_maillist</code> table reference
     */
    public TDmMaillist() {
        this(DSL.name("t_dm_maillist"), null);
    }

    public <O extends Record> TDmMaillist(Table<O> path, ForeignKey<O, TDmMaillistRecord> childPath, InverseForeignKey<O, TDmMaillistRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_MAILLIST);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmMaillistPath extends TDmMaillist implements Path<TDmMaillistRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmMaillistPath(Table<O> path, ForeignKey<O, TDmMaillistRecord> childPath, InverseForeignKey<O, TDmMaillistRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmMaillistPath(Name alias, Table<TDmMaillistRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmMaillistPath as(String alias) {
            return new TDmMaillistPath(DSL.name(alias), this);
        }

        @Override
        public TDmMaillistPath as(Name alias) {
            return new TDmMaillistPath(alias, this);
        }

        @Override
        public TDmMaillistPath as(Table<?> alias) {
            return new TDmMaillistPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmMaillistRecord, Integer> getIdentity() {
        return (Identity<TDmMaillistRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmMaillistRecord> getPrimaryKey() {
        return Keys.PK_DM_MAILLIST;
    }

    @Override
    public List<ForeignKey<TDmMaillistRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_MAILLIST__FK_ELEMENT_KEY, Keys.T_DM_MAILLIST__FK_DM_PERSON, Keys.T_DM_MAILLIST__FK_MAILLIST_RECIP);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_DM_MAILLIST__FK_ELEMENT_KEY, null);

        return _tCoreElementHierarchy;
    }

    private transient TDmPersonPath _tDmPerson;

    /**
     * Get the implicit join path to the <code>common_dd.t_dm_person</code>
     * table.
     */
    public TDmPersonPath tDmPerson() {
        if (_tDmPerson == null)
            _tDmPerson = new TDmPersonPath(this, Keys.T_DM_MAILLIST__FK_DM_PERSON, null);

        return _tDmPerson;
    }

    private transient TDmRecipientPath _tDmRecipient;

    /**
     * Get the implicit join path to the <code>common_dd.t_dm_recipient</code>
     * table.
     */
    public TDmRecipientPath tDmRecipient() {
        if (_tDmRecipient == null)
            _tDmRecipient = new TDmRecipientPath(this, Keys.T_DM_MAILLIST__FK_MAILLIST_RECIP, null);

        return _tDmRecipient;
    }

    @Override
    public TDmMaillist as(String alias) {
        return new TDmMaillist(DSL.name(alias), this);
    }

    @Override
    public TDmMaillist as(Name alias) {
        return new TDmMaillist(alias, this);
    }

    @Override
    public TDmMaillist as(Table<?> alias) {
        return new TDmMaillist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMaillist rename(String name) {
        return new TDmMaillist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMaillist rename(Name name) {
        return new TDmMaillist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMaillist rename(Table<?> name) {
        return new TDmMaillist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMaillist where(Condition condition) {
        return new TDmMaillist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMaillist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMaillist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMaillist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMaillist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMaillist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMaillist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMaillist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMaillist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMaillist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
